﻿using System;
using System.Linq;

using NHibernate;
using NHibernate.Cfg;
using NHibernate.Linq;
using NHibernateExamples.Model;

namespace NHibernateExamples
{
    class LinqListUsers
    {
        static void Main()
        {
            ISessionFactory sessionFactory =
                new Configuration().Configure().BuildSessionFactory();

            using (ISession session = sessionFactory.OpenSession())
            {
                using (ITransaction tx = session.BeginTransaction())
                {
                    var query = from user in session.Linq<User>()
                                select user;

                    foreach (User user in query)
                    {
                        Console.Out.WriteLine("{0}: {1}", user.Name, user.UserType);
                    }

                    tx.Commit();
                }
            }
        }
    }
}
