﻿using System.Collections.Generic;

namespace Chapter3.Variance
{
    public sealed class Fat32 : IStorageLocation<Fat32>
    {
        private readonly string name;

        public Fat32(string name)
        {
            this.name = name;
        }

        public IEnumerable<Fat32> GetSublocations()
        {
            if (name.EndsWith("\\"))
            {
                yield return new Fat32(name + "file1.txt");
                yield return new Fat32(name + "file2.txt");
                yield return new Fat32(name + "file3.txt");
            }
        }

        public string Name
        {
            get { return name; }
        }
    }
}
