﻿using System.Collections.Generic;
using MiscUtil;

namespace Chapter3.Variance
{
    /// <summary>
    /// The "magic drive" file system contains random sublocations,
    /// which change every time you ask about them.
    /// </summary>
    public sealed class MagicDrive : IStorageLocation<MagicDrive>
    {
        private readonly string name;

        public MagicDrive(string name)
        {
            this.name = name;
        }

        public IEnumerable<MagicDrive> GetSublocations()
        {
            for (int i = 0; i < StaticRandom.Next(7); i++)
            {
                yield return new MagicDrive(name + "\\" + GenerateRandomName());
            }
        }

        private static string GenerateRandomName()
        {
            char[] c = new char[StaticRandom.Next(3) + 5];
            for (int i=0; i < c.Length; i++)
            {
                c[i] = (char)(StaticRandom.Next(26) + 'a');
            }
            return new string(c);
        }

        public string Name
        {
            get { return name; }
        }
    }
}
