using System;
using System.ComponentModel;
using System.IO;

namespace Chapter5
{
    [Description("Listing 5.3")]
    class Covariance
    {
        delegate Stream StreamFactory();

        static MemoryStream GenerateRandomData()
        {
            byte[] buffer = new byte[16];
            new Random().NextBytes(buffer);
            return new MemoryStream(buffer);
        }

        static void Main()
        {
            StreamFactory factory = GenerateRandomData;

            Stream stream = factory();
            int data;
            while ((data = stream.ReadByte()) != -1)
            {
                Console.WriteLine(data);
            }
        }
    }
}
